using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping; 
using Syncfusion.Grouping; 

namespace GGCdynamiccontextMenu
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			GridEngineFactory.Factory = new GroupingEngineFactoryPF(); 
			InitializeComponent();
			this.gridGroupingControl1.TableControlCellDoubleClick += new GridTableControlCellClickEventHandler(gridGroupingControl1_TableControlCellDoubleClick);
			this.gridGroupingControl1.TableControlCurrentCellControlDoubleClick += new GridTableControlControlEventHandler(gridGroupingControl1_TableControlCurrentCellControlDoubleClick);

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		DataTable GetTable()
		{
			DataTable dt = new DataTable();
			for(int i = 1 ;i < 6 ;i++)
				dt.Columns.Add("col"+i.ToString());

			int group = 0;
			for(int j= 0 ;j< 2000;j++)
			{
				Random rand = new Random();
				int randNum = rand.Next(1, 10);
				if (randNum < 3)
					group++;
				dt.Rows.Add(new object[]{j,"Col2"+j.ToString(),"Col3"+j.ToString(),"Col4"+j.ToString(), group});     
			}
			return dt;

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			Syncfusion.Windows.Forms.Grid.Grouping.GridColumnSetDescriptor gridColumnSetDescriptor1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnSetDescriptor();
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 16);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(632, 376);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableDescriptor.Columns.AddRange(new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor[] {
																																			 new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor("col1"),
																																			 new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor("col2"),
																																			 new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor("col3"),
																																			 new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor("col4"),
																																			 new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor("col5")});
			gridColumnSetDescriptor1.ColumnSpans.AddRange(new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnSpanDescriptor[] {
																																	new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnSpanDescriptor("col1", "R0C0"),
																																	new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnSpanDescriptor("col2", "R0C1"),
																																	new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnSpanDescriptor("col3", "R0C2"),
																																	new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnSpanDescriptor("col4", "R1C0:R1C2"),
																																	new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnSpanDescriptor("col5", "R2C0:R2C2")});
			gridColumnSetDescriptor1.Name = "ColumnSet 1";
			this.gridGroupingControl1.TableDescriptor.ColumnSets.AddRange(new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnSetDescriptor[] {
																																				   gridColumnSetDescriptor1});
			this.gridGroupingControl1.TableOptions.AllowSelection = ((Syncfusion.Windows.Forms.Grid.GridSelectionFlags)(((((Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Row | Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Column) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Cell) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Multiple) 
				| Syncfusion.Windows.Forms.Grid.GridSelectionFlags.Shift)));
			this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.MultiExtended;
			this.gridGroupingControl1.TableOptions.SelectionBackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(128)));
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.TableControlResizingRows += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlResizingRowsEventHandler(this.gridGroupingControl1_TableControlResizingRows);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(544, 408);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(96, 32);
			this.button1.TabIndex = 1;
			this.button1.Text = "HidRows";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(664, 462);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.DataSource = GetTable();
			
  			this.gridGroupingControl1.TableDescriptor.AllowCalculateMaxColumnWidth = false;
		
			this.gridGroupingControl1.TableControl.WantEnterKey = false;
			this.gridGroupingControl1.TableControl.AllowTextBoxAutoSize = true;

			gridGroupingControl1.TableDescriptor.SortedColumns.Add("col5");
			gridGroupingControl1.TableDescriptor.UnboundFields.Add("test");
			gridGroupingControl1.QueryValue += new FieldValueEventHandler(gridGroupingControl1_QueryValue);
			gridGroupingControl1.TableDescriptor.GroupedColumns.Add("test");
   
			//For ResizeTofit option....
//			GridTableModel tm = this.gridGroupingControl1.TableModel ;
//			tm.RowHeights.ResizeToFit(GridRangeInfo.Table()  , GridResizeToFitOptions.ResizeCoveredCells);
//			
//			this.gridGroupingControl1.TableControl.Model.Options.ActivateCurrentCellBehavior = GridCellActivateAction.None;      
		}

				
		//Prevent the RowResize..
		private void gridGroupingControl1_TableControlResizingRows(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlResizingRowsEventArgs e)
		{
//			if(e.Inner.Rows.Top % 2 == 0)  
//			{
//				e.Inner.Cancel = true;
//			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			foreach (GridRecord rec in  this.gridGroupingControl1.Table.UnsortedRecords)
			{
				Random r = new Random();
				int row1 = r.Next(0, 2);
				int row2 = (row1 + 1) % 3;
				((IGridRowHeight)rec.RecordRows[row1]).RowHeight = 0;
				((IGridRowHeight)rec.RecordRows[row2]).RowHeight = 18;
			}
			this.gridGroupingControl1.Reinitialize();   
		}

		private void gridGroupingControl1_TableControlCellDoubleClick(object sender, GridTableControlCellClickEventArgs e)
		{
			MessageBox.Show("Double Click on Cell");
		}

		private void gridGroupingControl1_TableControlCurrentCellControlDoubleClick(object sender, GridTableControlControlEventArgs e)
		{
			MessageBox.Show("Double Click on  Current Cell");
		}

		private void gridGroupingControl1_QueryValue(object sender, FieldValueEventArgs e)
		{
			if (e.Record.GetValue("col5") == DBNull.Value)
			{
				e.Value = "0000000000";
				return;
			}

			double rule_num = double.Parse(e.Record.GetValue("col5").ToString());
			string rule = rule_num.ToString("0000000000.00000");
			e.Value = rule;

		}
	}
}
